﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

*/
package 
{

	import flash.events.MouseEvent;
	import com.demonsters.debugger.MonsterDebugger;

	import flash.display.Sprite;
	
	import flash.events.Event;

	

	public class Main extends Sprite
	{
		private var oTicket : Sprite;
		private var oContent : Sprite;
		private var oBtn : ButtonValider;
		private var oTicketAgratter : TicketAgratter;
	
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}
		
		
		/**
		 * Démarrage de l'application.
		 * 
		 */
		protected function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
            MonsterDebugger.initialize(this);
            MonsterDebugger.trace(this, "Start Application");
			
			oBtn = new ButtonValider();
			oBtn.addEventListener(MouseEvent.CLICK, onBuildTicket);
			
			oContent = new Sprite();
			addChild(oContent);
			addChild(oBtn);
			
			this.onBuildTicket(null);
		}
		

		private function onStartGrattage(e:Event):void
		{
			MonsterDebugger.trace(this, "le ticket commence à être gratté par le joueur.");
		}
		
		
		private function onGrattageComplete(e:Event):void
		{
			MonsterDebugger.trace(this, "Le grattage du ticket est terminé !");
			oBtn.visible = true;	
		}


		/**
		 * Construction du ticket à gratter.
		 * 
		 */
		private function onBuildTicket(event : MouseEvent) : void
		{
			oBtn.visible = false;
			if(oTicket)	oContent.removeChild(oTicket);
			oTicket = new Sprite();
			oContent.addChild(oTicket);
			
			if(oTicketAgratter)
			{
				oTicketAgratter.removeEventListener(Event.COMPLETE,onGrattageComplete);
				oTicketAgratter.removeEventListener(Event.OPEN,onStartGrattage);
				oTicketAgratter.destroy();
			}
			
			oTicketAgratter = new TicketAgratter(oTicket, 80, "http://www.actionscript-facile.com/ressources/images/ticket-gratte.png", "http://www.actionscript-facile.com/ressources/images/ticket-a-gratter.png");
			oTicketAgratter.addEventListener(Event.COMPLETE,onGrattageComplete);
			oTicketAgratter.addEventListener(Event.OPEN,onStartGrattage);
		}
	
	}
}
